<?php
	// kDL 4.0 (HU version) by kgyt.eu
	// ---------------------------------------------------------------------------
	//
	// Settings
	//
	setlocale(LC_ALL, 'hu_HU.UTF-8');
	$kdl['longfilename'] = 45;               // Length of long filenames
	$kdl['dateformat']   = '%Y. %B %e., %A'; // Date format
	$kdl['theme']        = 'kgyt';           // Theme from installed themes
	$global = array(
		'url'   => '//kgyt.eu/',      // URL of the firm
		'url2'  => 'kgyt.eu',         // URL of the firm
		'name'  => 'kDL',             // Name of firm
		'tel'   => '+36 20 599 5758', // Phone of firm
		'fax'   => '',                // Fax of firm
		'email' => 'kgyt@kgyt.eu'     // E-mail of firm
	);
	//
	// ---------------------------- DON'T EDIT UNDER THIS LINE -------------------
	//
	// Version
	$kdl['version'] = '4.0';
	// Directories
	$kdl['dirs']['public'] = '//kdl.kgyt.eu/4.0/'; // Install directory
	$kdl['dirs']['theme'] = $kdl['dirs']['public'] . 'themes/' . $kdl['theme'] . '/';
	// JSON
	$json_url = 'https:' . $kdl['dirs']['public'] . 'extension.php?ext=';
	//
	// Listing mode settings
	//
	$listingmode = false;
	// Filename for default listing mode's file
	$kdl['listingfile'] = 'index.kdl';
	// Set path info if needed - or filter for security
	if(! isset($_SERVER['PATH_INFO'] )) {
		$_SERVER['PATH_INFO'] = 'index';
	} else {
		$_SERVER['PATH_INFO'] =
			preg_replace('/\W/', '', $_SERVER['PATH_INFO']);
	};
	// Get special listing file from path info
	$kdl['pathinfo'] = $_SERVER['PATH_INFO'] . '.kdl';
	if(is_file($kdl['pathinfo'] )) {
		$kdl['listingfile'] = $kdl['pathinfo'];
	};
	if(is_file($kdl['listingfile'] )) {
		$filelines = file($kdl['listingfile']);
		if(preg_match('/^\#/', $filelines[ 0 ] )) {
			$listingmode = true;
		};
	};
	//
	// Initialize variables
	//
	$kdl['list'][ 'files' ]  = array();
	$kdl['list'][ 'dirs' ]   = array();
	$kdl['dirs'][ 'actual' ] =
		preg_replace('/^(.*\/)[^\/]+$/', '\\1', $_SERVER['SCRIPT_NAME']);
	//
	// Titles
	if($listingmode) {
		$kdl['title'][ 'h1' ]   = rtrim($filelines[ 3 ]);
		$kdl['title'][ 'head' ] = $kdl['title'][ 'h1' ];
	} else {
		$kdl['title'][ 'h1' ]   = $kdl['dirs']['actual'];
		$kdl['title'][ 'head' ] = $kdl['title'][ 'h1' ] . ' – '
			. $_SERVER['HTTP_HOST'];
	};
	//
	// Functions
	//
	// ---------------------------------------------------------------------------
	//
	// Normal mode function
	//
	function normalmode($filelines) {
		global $global;
		global $kdl;
		echo '	<table class="table table-bordered table-hover table-striped">' . "\n";
		if(is_dir('.' )) {
			if($dirhandler = opendir('.' )) {
				$kdl['list']['sortbytype']['files'] = array();
				$kdl['list']['sortbysize']['files'] = array();
				$kdl['list']['sortbytime']['files'] = array();
				while($file = readdir($dirhandler )) {
					if(preg_replace('/^.*\/([^\/]+)$/', '\\1', $_SERVER['SCRIPT_NAME'] ) == $file) {
						// Self
					} elseif(preg_match('/\.kdl$/', $file )) {
						// kDL list files
					} elseif(preg_match('/\.kdi$/', $file )) {
						// kDL info files
					} elseif(preg_match('/\.kdh$/', $file ) || preg_match('/\.hidden$/', $file )) {
						// kDL hidden files
					} elseif(is_file($file . '.kdh' ) || is_file($file . '.hidden' )) {
						// kDL hidden files
					} elseif('..' == $file) {
						// Parent folder
					} elseif(preg_match('/^\./', $file )) {
						// Linux hidden files
					} else {
						// File or dir
						if(strlen($file ) > $kdl['longfilename']) {
							$shortfilename = substr($file, 0, $kdl['longfilename'] - 3 ) . '<span class="note">...</span>';
						} else {
							$shortfilename = $file;
						};
						if(is_dir($file )) {
							$moreinfo = '';
							$noteinfo = '';
							if(is_file($file . '.kdi' )) {
								$infofile = file($file . '.kdi');
								if(preg_match('/^\#/', $infofile[ 0 ] )) {
									$moreinfo = ' – ' . rtrim($infofile[ 2 ]);
									$noteinfo = '<br />' . "\n\t\t\t\t"
									. '<span class="note">' . rtrim($infofile[ 3 ] ) . '</span>';
								};
							};
							$type = 'DIR';
							$size = '&lt;DIR&gt;';
							$time = '' . strftime($kdl['dateformat'], filemtime($file));
							$kdl['list']['dirs'][ $file ] = array(
								'file'  => $file,
								'short' => $shortfilename,
								'type'  => $type,
								'size'  => $size,
								'time'  => $time,
								'more'  => $moreinfo,
								'note'  => $noteinfo
							);
							$timeforsort = filemtime($file ) - 0;
							$kdl['list']['sortbytime']['dirs'][ $timeforsort ][ $file ] = $kdl['list']['dirs'][ $file ];
						} else {
							$moreinfo = '';
							$noteinfo = '';
							if(is_file($file . '.kdi')) {
								$infofile = file($file . '.kdi');
								if(preg_match('/^\#/', $infofile[ 0 ] )) {
									$moreinfo = ' – ' . rtrim($infofile[ 2 ]);
									$noteinfo = '<br />' . "\n\t\t\t\t\t\t"
									. '<span class="note">' . rtrim($infofile[ 3 ] ) . '</span>';
								};
							};
							$type = strtolower(preg_replace('/^.+\.([^\.]+)$/', '\\1', $file ));
							$size = '';
							$sizeforsort = filesize($file) - 0;
							if($sizeforsort > 1000) {
								if($sizeforsort > 1000000000000) {
									$size_TB = round($sizeforsort / 1000000000000, 2);
									$size .= preg_replace('/\./', ',', $size_TB) . '&nbsp;TB';
								} elseif($sizeforsort > 1000000000) {
									$size_GB = round($sizeforsort / 1000000000, 2);
									$size .= preg_replace('/\./', ',', $size_GB) . '&nbsp;GB';
								} elseif($sizeforsort > 1000000) {
									$size_MB = round($sizeforsort / 1000000, 2);
									$size .= preg_replace('/\./', ',', $size_MB) . '&nbsp;MB';
								} else {
									$size_kB = round($sizeforsort / 1000, 2);
									$size .= preg_replace('/\./', ',', $size_kB) . '&nbsp;kB';
								};
								$size .= '/';
								if($sizeforsort > 1024 * 1024 * 1024 * 1024) {
									$size_TB = round($sizeforsort / (1024 * 1024 * 1024 * 1024), 2);
									$size .= preg_replace('/\./', ',', $size_TB) . '&nbsp;TiB';
								} elseif($sizeforsort > 1024 * 1024 * 1024) {
									$size_GB = round($sizeforsort / (1024 * 1024 * 1024), 2);
									$size .= preg_replace('/\./', ',', $size_GB) . '&nbsp;GiB';
								} elseif($sizeforsort > 1024 * 1024) {
									$size_MB = round($sizeforsort / (1024 * 1024), 2);
									$size .= preg_replace('/\./', ',', $size_MB) . '&nbsp;MiB';
								} else {
									$size_kB = round($sizeforsort / 1024, 2);
									$size .= preg_replace('/\./', ',', $size_kB) . '&nbsp;kiB';
								};
								$size .= ' (' . $sizeforsort . '&nbsp;B)';
							} else {
								$size .= '' . $sizeforsort . '&nbsp;B';
							};
							$time = '' . strftime($kdl['dateformat'], filemtime($file));
							$kdl['list']['files'][$file] = array(
								'file'  => $file,
								'short' => $shortfilename,
								'type'  => $type,
								'size'  => $size,
								'time'  => $time,
								'more'  => $moreinfo,
								'note'  => $noteinfo
							);
							$timeforsort = filemtime($file ) - 0;
							$kdl['list']['sortbytype']['files'][ $type ][ $file ] = $kdl['list']['files'][ $file ];
							$kdl['list']['sortbysize']['files'][ $sizeforsort ][ $file ] = $kdl['list']['files'][ $file ];
							$kdl['list']['sortbytime']['files'][ $timeforsort ][ $file ] = $kdl['list']['files'][ $file ];
						};
					};
				};
				closedir($dirhandler);
			};
		};
		sort($kdl['list']['dirs']);
		sort($kdl['list']['files']);
		if($_GET['sort'] === 'name2') {
			$kdl['list']['dirs'] = array_reverse($kdl['list']['dirs']);
			$kdl['list']['files'] = array_reverse($kdl['list']['files']);
		} elseif($_GET['sort'] === 'type') {
			ksort($kdl['list']['sortbytype']['files']);
			$kdl['list']['files'] = array();
			foreach($kdl['list']['sortbytype']['files'] as $sortnow) {
				$sortnow = array_values($sortnow);
				foreach($sortnow as $sortnow2) {
					$kdl['list']['files'][] = $sortnow2;
				};
			};
		} elseif($_GET['sort'] === 'type2') {
			$kdl['list']['dirs'] = array_reverse($kdl['list']['dirs']);
			krsort($kdl['list']['sortbytype']['files']);
			$kdl['list']['files'] = array();
			foreach($kdl['list']['sortbytype']['files'] as $sortnow) {
				$sortnow = array_values($sortnow);
				foreach($sortnow as $sortnow2) {
					$kdl['list']['files'][] = $sortnow2;
				};
			};
		} elseif($_GET['sort'] === 'size') {
			ksort($kdl['list']['sortbysize']['files']);
			$kdl['list']['files'] = array();
			foreach($kdl['list']['sortbysize']['files'] as $sortnow) {
				$sortnow = array_values($sortnow);
				foreach($sortnow as $sortnow2) {
					$kdl['list']['files'][] = $sortnow2;
				};
			};
		} elseif($_GET['sort'] === 'size2') {
			krsort($kdl['list']['sortbysize']['files']);
			$kdl['list']['files'] = array();
			foreach($kdl['list']['sortbysize']['files'] as $sortnow) {
				$sortnow = array_values($sortnow);
				foreach($sortnow as $sortnow2) {
					$kdl['list']['files'][] = $sortnow2;
				};
			};
		} elseif($_GET['sort'] === 'time') {
			ksort($kdl['list']['sortbytime']['dirs']);
			$kdl['list']['dirs'] = array();
			foreach($kdl['list']['sortbytime']['dirs'] as $sortnow) {
				$sortnow = array_values($sortnow);
				foreach($sortnow as $sortnow2) {
					$kdl['list']['dirs'][] = $sortnow2;
				};
			};
			ksort($kdl['list']['sortbytime']['files']);
			$kdl['list']['files'] = array();
			foreach($kdl['list']['sortbytime']['files'] as $sortnow) {
				$sortnow = array_values($sortnow);
				foreach($sortnow as $sortnow2) {
					$kdl['list']['files'][] = $sortnow2;
				};
			};
		} elseif($_GET['sort'] === 'time2') {
			krsort($kdl['list']['sortbytime']['dirs']);
			$kdl['list']['dirs'] = array();
			foreach($kdl['list']['sortbytime']['dirs'] as $sortnow) {
				$sortnow = array_values($sortnow);
				foreach($sortnow as $sortnow2) {
					$kdl['list']['dirs'][] = $sortnow2;
				};
			};
			krsort($kdl['list']['sortbytime']['files']);
			$kdl['list']['files'] = array();
			foreach($kdl['list']['sortbytime']['files'] as $sortnow) {
				$sortnow = array_values($sortnow);
				foreach($sortnow as $sortnow2) {
					$kdl['list']['files'][] = $sortnow2;
				};
			};
		};
?>
		<thead class="thead-dark">
			<tr>
				<th class="py-1">
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>">név
						<i class="fas fa-sort-alpha-down"></i></a>
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=name2">
						<i class="fas fa-sort-alpha-up"></i></a>
				</th>
				<th class="py-1">
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=type2">típus
						<i class="fas fa-sort-alpha-down"></i></a>
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=type">
						<i class="fas fa-sort-alpha-up"></i></a>
				</th>
				<th class="py-1">
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=size">méret
						<i class="fas fa-sort-numeric-down"></i></a>
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=size2">
						<i class="fas fa-sort-numeric-up"></i></a>
				</th>
				<th class="py-1">
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=time">idő
						<i class="fas fa-sort-numeric-down"></i></a>
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=time2">
						<i class="fas fa-sort-numeric-up"></i></a>
				</th>
			</tr>
		</thead>
		<tfoot class="thead-dark">
			<tr>
				<th class="py-1">
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>">név
						<i class="fas fa-sort-alpha-down"></i></a>
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=name2">
						<i class="fas fa-sort-alpha-up"></i></a>
				</th>
				<th class="py-1">
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=type2">típus
						<i class="fas fa-sort-alpha-down"></i></a>
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=type">
						<i class="fas fa-sort-alpha-up"></i></a>
				</th>
				<th class="py-1">
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=size">méret
						<i class="fas fa-sort-numeric-down"></i></a>
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=size2">
						<i class="fas fa-sort-numeric-up"></i></a>
				</th>
				<th class="py-1">
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=time">idő
						<i class="fas fa-sort-numeric-down"></i></a>
					<a class="btn btn-outline-light btn-dark" href="<?php echo $kdl['dirs']['actual']; ?>?sort=time2">
						<i class="fas fa-sort-numeric-up"></i></a>
				</th>
			</tr>
		</tfoot>
		<tbody>
<?php
		if(!preg_match('/^\/$/', $kdl['dirs']['actual'])) {
?>
			<tr onclick="window.location='..'">
				<td><strong>
					<a href="../"><i class="far fa-folder"></i>&nbsp;..</a>
				</strong></td>
				<td><?php echo extension2filetype('DIR'); ?></td>
				<td class="text-right">&lt;DIR&gt;</td>
				<td class="text-right"><?php echo strftime($kdl['dateformat'], filemtime('..')); ?></td>
			</tr>
<?php
		};
		foreach($kdl['list']['dirs'] as $a1 => $a2) {
?>
			<tr onclick="window.location='<?php echo $kdl['dirs']['actual'] . $a2['file']; ?>'">
				<td><strong>
					<a href="<?php echo $kdl['dirs']['actual'] . $a2['file']; ?>"><i class="far fa-folder"></i>&nbsp;<?php echo $a2['short']; ?></a>
				</strong><?php echo $a2['more']; ?><?php echo $a2['note']; ?></td>
				<td><?php echo extension2filetype($a2['type']); ?></td>
				<td class="text-right"><?php echo $a2['size']; ?></td>
				<td class="text-right"><?php echo $a2['time']; ?></td>
			</tr>
<?php
		};
		foreach($kdl['list']['files'] as $a1 => $a2) {
?>
			<tr onclick="window.location='<?php echo $kdl['dirs']['actual'] . $a2['file']; ?>'">
				<td><strong>
					<a href="<?php echo $kdl['dirs']['actual'] . $a2['file']; ?>"><?php
						echo extension2icon($a2['type']);
					?>&nbsp;<?php echo $a2['short']; ?></a>
				</strong><?php echo $a2['more']; ?><?php echo $a2['note']; ?></td>
				<td><?php echo extension2filetype($a2['type']); ?></td>
				<td class="text-right"><?php echo $a2['size']; ?></td>
				<td class="text-right"><?php echo $a2['time']; ?></td>
			</tr>
<?php
		};
?>
		</tbody>
	</table>
<?php
	}
	// ---------------------------------------------------------------------------
	//
	// Listing mode function
	//
	function listingmode($filelines) {
		global $global;
		global $kdl;
		if(rtrim($filelines[ 4 ] ) != '') {
			echo '			<p><strong>' . rtrim($filelines[ 4 ] ) . '</strong></p>';
		};
		for($i = 5; $i < count($filelines); $i++) {
			$fileline = rtrim($filelines[ $i ]);
			if($fileline != '') {
				if(preg_match('/^\=\s+/', $fileline )) {
					$fileline = preg_replace('/^\=\s+/', '', $fileline);
					echo '			<h2>' . $fileline . "</h2>\n";
				} elseif(preg_match('/^\-\s+/', $fileline )) {
					$fileline = preg_replace('/^\-\s+/', '', $fileline);
					echo '			<h3>' . $fileline . "</h3>\n";
				} elseif(preg_match('/^\i\s+/', $fileline )) {
					$fileline = preg_replace('/^\i\s+/', '', $fileline);
					echo '			<p class="small"><small>' . $fileline . "</small></p>\n";
				} else {
					if(	is_file($fileline ) || is_dir($fileline )) {
						if(preg_replace('/^.*\/([^\/]+)$/', '\\1', $_SERVER['SCRIPT_NAME'] ) == $fileline) {
							// Self
						} elseif(preg_match('/\.kdl$/', $fileline )) {
							// kDL list files
						} elseif(preg_match('/\.kdi$/', $fileline )) {
							// kDL info files
						} elseif(preg_match('/\.kdh$/', $fileline ) || preg_match('/\.hidden$/', $fileline )) {
							// kDL hidden files
						} elseif('..' == $fileline) {
							// Parent folder
						} elseif(preg_match('/^\./', $fileline )) {
							// Linux hidden files
						} else {
							$moreinfo = '';
							if(is_file($fileline . '.kdi' )) {
								$infofile = file($fileline . '.kdi');
								if(preg_match('/^\#/', $infofile[ 0 ] )) {
									$moreinfo = ' – ' . rtrim($infofile[ 2 ]);
								};
							};
							if(is_dir($fileline )) {
								echo "			<p class=\"linkdir\" onclick=\"window.location='"
								. $kdl['dirs']['actual'] . $fileline . '\'">'
								. '<a href="'
								. $kdl['dirs']['actual'] . $fileline . '">'
								. $fileline . '</a>'
								. $moreinfo . ' // '
								. extension2filetype('DIR')
								. ' // '
								. strftime($kdl['dateformat'], filemtime($fileline))
								. '</p>' . "\n";
							} else {
								echo "			<p class=\"link\" onclick=\"window.location='"
								. $kdl['dirs']['actual'] . $fileline . '\'">'
								. '<a href="'
								. $kdl['dirs']['actual'] . $fileline . '">'
								. $fileline . '</a>'
								. $moreinfo . ' // '
								. extension2filetype(strtolower(preg_replace('/^.+\.([^\.]+)$/', '\\1', $fileline)))
								. ' // '
								. filesize($fileline)
								. '&nbsp;B // '
								. strftime($kdl['dateformat'], filemtime($fileline))
								. '</p>' . "\n";
							};
						};
					};
				};
			};
		};
	}
	// ---------------------------------------------------------------------------
	//
	// Extension functions
	//
	function extension2filetype($ext) {
		global $json_url;
		$json_obj = json_decode(file_get_contents($json_url . $ext));
		if($json_obj && is_object($json_obj) && $json_obj->status) {
			return $json_obj->description;
		};
		return 'Ismeretlen fájltípus';
	}
	function extension2icon($ext) {
		global $json_url;
		$json_obj = json_decode(file_get_contents($json_url . $ext));
		if($json_obj && is_object($json_obj) && $json_obj->status) {
			return $json_obj->icon;
		};
		return '<i class="far fa-file"></i>';
	}
	// ---------------------------------------------------------------------------
	//
	// XHTML header function
	//
	function htmlheader($title, $dirs) {
		global $global;
		header('Content-type: text/html; charset=utf-8');
		header('Expires: Thu, 19 Nov 1981 08:52:00 GMT');
		header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
		header('Pragma: no-cache');
		header('Connection: close');
		header('X-Powered-By: kgyt');
?><!DOCTYPE html>
<html lang="hu" dir="ltr">
<head>
	<title><?=$title['head']?></title>
	<meta charset="utf-8" />
	<meta name="viewport" content="width=device-width, initial-scale=1" />
	<link rel="icon" href="<?=$dirs['theme']?>favicon.ico" />
	<link rel="shortcut icon" href="<?=$dirs['theme']?>favicon.ico" />
	<link rel='stylesheet' href='https://use.fontawesome.com/releases/v5.8.1/css/all.css'
		integrity='sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf'
		crossorigin='anonymous' />
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" />
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
	<link rel="stylesheet" href="<?=$dirs['theme']?>css/main.css" />
</head>
<body>
<nav class="navbar navbar-expand-md bg-dark navbar-dark">
	<a href="https://kgyt.eu/" class="navbar-brand"><img src="https://kgyt.eu/images/kgyt_logo_white.svg"
		class="site-logo" alt="logo" /> kgyt.eu</a>
	<button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#collapsibleNavbar">
		<span class="navbar-toggler-icon"></span>
	</button>
	<div class="collapse navbar-collapse justify-content-center" id="collapsibleNavbar">
		<ul class="navbar-nav">
			<li class="nav-item">
				<a class="nav-link" href="https://cv.kgyt.eu/"><i class='far fa-file-alt'></i> CV</a>
			</li>
			<li class="nav-item">
				<a class="nav-link" href="http://blog.kgyt.eu/"><i class='fas fa-blog'></i> blog</a>
			</li>
			<li class="nav-item">
				<a class="nav-link" href="http://faq.kgyt.eu/"><i class='far fa-question-circle'></i> FAQ</a>
			</li>
		</ul>
	</div>
</nav>
<div class="container py-3" id="page">
	<h1><?=$title['h1']?></h1>
<?php
	}
	// ---------------------------------------------------------------------------
	//
	// XHTML footer function
	//
	function htmlfooter($dirs) {
		global $global;
?>
</div>
<div class="text-center bg-dark text-white m-0 mt-3 p-1 pb-3">
	<p>
		Copyright <i class='far fa-copyright'><span class="d-none">©</span></i> 1993–<?php echo date('Y'); ?>.
		<a href="https://kgyt.eu/" class="text-info">Károly György Tamás</a>
		<a href="tel:+36205995758" class="text-info ml-2"><i class="fas fa-phone-square text-white"></i>
			+36&nbsp;20&nbsp;5995758</a>
		<a href="mailto:kgyt@kgyt.eu" class="text-info ml-2"><i class="far fa-envelope text-white"></i>
			kgyt@kgyt.eu</a>
	</p>
</div>
</body>
</html><?php
	}
	// ---------------------------------------------------------------------------
	// Build the page
	// ---------------------------------------------------------------------------
	htmlheader($kdl['title'], $kdl['dirs']);
	if($listingmode) {
		listingmode($filelines);
	} else {
		normalmode($filelines);
	};
	htmlfooter($kdl['dirs']);
	// -------------------------- END OF FILE ------------------------------------
?>